#!/bin/sh
usage() {
  echo "Usage:"
  echo "  find [...] -print0 | $0 \\"
  echo "    path_to_helper parallelism state_dir out_file command [arg1 [...]]"
  echo "Reads filenames to process from stdin, null-delimited."
}

if [ $1 = '-h' -o $1 = '--help' ]; then
  usage
  exit 0
fi

HELPER=$1
if [ ! -x "$HELPER" ]; then
  echo "$HELPER cannot be executed"
  exit 1
fi
shift
PARALLELISM=$1
shift
STATE_DIR=$1
mkdir -p "$STATE_DIR" || exit $?
shift
OUT_FILE=$1
shift

if [ $# -eq 0 ]; then
  usage
  exit 1
fi

xargs -0 -r -n 1 -P $PARALLELISM -I "@FILE@" "$HELPER" "@FILE@" "$STATE_DIR" "$@"
"$@" --out "$OUT_FILE" --state-file "$STATE_DIR"/*
